#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire2800six4xi.py">
#<abstract4xi abstract = "fires to direction six and to distance 2800"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2six4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
       
# -------------------------------------------------------------------------------------------------
# SHOT2SIX - COORDINATE SIGNS OF SHOOT2SIX4XI: (X - ,Y + ,Z - )
# -------------------------------------------------------------------------------------------------    
global shot2six28004xi


# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False

shot2six28004xi = {
                1:'-1001x2475y-842z',
                2:'-1020x1507y-2127z',
                3:'-1085x1435y-2145z',
                4:'-1089x2411y-914z',
                5:'-1126x2411y-868z',
                6:'-1144x1360y-2163z',
                7:'-1199x1282y-2180z',
                8:'-1209x2343y-941z',
                9:'-1246x2341y-895z',
                10:'-1249x1202y-2198z',
                11:'-1293x1121y-2215z',
                12:'-1325x2268y-967z',
                13:'-1333x1038y-2232z',
                14:'-1362x2265y-921z',
                15:'-1367x954y-2249z',
                16:'-1396x869y-2265z',
                17:'-139x1102y-2570z',
                18:'-1409x47y-2418z',
                19:'-1419x784y-2282z',
                20:'-1429x122y-2404z',
                21:'-1437x2187y-993z',
                22:'-1438x698y-2298z',
                23:'-1444x200y-2390z',
                24:'-1451x613y-2314z',
                25:'-1455x280y-2375z',
                26:'-1460x528y-2329z',
                27:'-1461x362y-2360z',
                28:'-1463x444y-2345z',
                29:'-1474x2183y-948z',
                30:'-1543x2101y-1019z',
                31:'-1580x2095y-974z',
                32:'-1645x2009y-1045z',
                33:'-1681x2002y-1000z',
                34:'-1740x1913y-1071z',
                35:'-1766x2172y-8z',
                36:'-1777x1904y-1026z',
                37:'-1830x1811y-1097z',
                38:'-1867x1801y-1052z',
                39:'-1878x2076y-36z',
                40:'-1914x1706y-1123z',
                41:'-192x1067y-2581z',
                42:'-1950x1694y-1078z',
                43:'-1983x1974y-64z',
                44:'-1992x1596y-1148z',
                45:'-2028x1582y-1104z',
                46:'-2064x1483y-1174z',
                47:'-2083x1867y-92z',
                48:'-2099x1468y-1130z',
                49:'-2128x1366y-1199z',
                50:'-2163x1350y-1155z',
                51:'-2177x1755y-120z',
                52:'-2187x1247y-1224z',
                53:'-2220x1229y-1181z',
                54:'-2238x1125y-1250z',
                55:'-2265x1638y-148z',
                56:'-2282x1001y-1275z',
                57:'-2319x876y-1299z',
                58:'-2347x1516y-175z',
                59:'-2350x749y-1324z',
                60:'-2352x1145y-1249z',
                61:'-2373x622y-1349z',
                62:'-2389x494y-1373z',
                63:'-2394x112y-1446z',
                64:'-2398x366y-1398z',
                65:'-2399x239y-1422z',
                66:'-2421x1390y-203z',
                67:'-242x1031y-2591z',
                68:'-247x1989y-1954z',
                69:'-2489x1261y-231z',
                70:'-2549x1128y-259z',
                71:'-2602x992y-287z',
                72:'-2647x853y-315z',
                73:'-2685x713y-343z',
                74:'-2715x570y-371z',
                75:'-2738x427y-398z',
                76:'-2752x283y-426z',
                77:'-2759x138y-454z',
                78:'-288x992y-2602z',
                79:'-295x2680y-754z',
                80:'-331x951y-2612z',
                81:'-347x1954y-1974z',
                82:'-371x908y-2622z',
                83:'-384x11y-2773z',
                84:'-407x863y-2632z',
                85:'-411x34y-2769z',
                86:'-434x2653y-781z',
                87:'-436x59y-2765z',
                88:'-439x818y-2641z',
                89:'-444x1913y-1994z',
                90:'-459x87y-2760z',
                91:'-467x771y-2650z',
                92:'-470x2660y-734z',
                93:'-481x117y-2755z',
                94:'-492x723y-2659z',
                95:'-501x150y-2750z',
                96:'-513x675y-2668z',
                97:'-518x186y-2745z',
                98:'-530x627y-2676z',
                99:'-533x223y-2739z',
                100:'-538x1868y-2014z',
                101:'-544x579y-2684z',
                102:'-545x263y-2733z',
                103:'-554x304y-2727z',
                104:'-554x531y-2692z',
                105:'-561x347y-2721z',
                106:'-561x484y-2700z',
                107:'-564x391y-2714z',
                108:'-564x437y-2707z',
                109:'-571x2619y-808z',
                110:'-607x2625y-761z',
                111:'-629x1818y-2033z',
                112:'-705x2577y-834z',
                113:'-716x1764y-2052z',
                114:'-741x2582y-788z',
                115:'-798x1705y-2071z',
                116:'-836x2529y-861z',
                117:'-83x1133y-2558z',
                118:'-873x2532y-815z',
                119:'-877x1643y-2090z',
                120:'-951x1577y-2108z',
                121:'-964x2473y-888z'}


#"
#/>


# -------------------------------------------------------------------------------------------------------------------
#<function4xi function = "fire2800six4xi" usage = "target function for charge2six4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------------------------
def fire2800six4xi(queue2six, consumer_channel2six, publisher_channel2six):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE2800SIX4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE2800SIX4XI -  QUEUE2SIX: ", queue2six)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE2800SIX4XI -  CONSUMER_CHANNEL2SIX: ", consumer_channel2six)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE2800SIX4XI -  PUBLISHER_CHANNEL2SIX: ", publisher_channel2six)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE2800SIX4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2SIX: ", queue2six, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2six.put(shot2six28004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE2800SIX4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2SIX: ", queue2six, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE2800SIX4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2SIX: ", queue2six, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE2800SIX4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2SIX: ", publisher_channel2six, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2six8shot2six2800x4xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2six8shot2six2800x4xi</nack2put4xi>" 
            
        publisher_channel2six.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE2800SIX4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2SIX: ", publisher_channel2six, " - TIME: ", time4xi()) 
            # 
        
    except:
        print(" (STEP 3C/33) OF FIRE2800SIX4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2SIX: ", publisher_channel2six, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE2800SIX4XI - RETURNING QUEUE OBJECT QUEUE2SIX: ", queue2six, " - TIME: ", time4xi())  
        # 
            
    return queue2six    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire2800six4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
